#!/bin/csh
#
# 2007/8/22
#

setenv LANG C

set machine = "nt1, Pentium4 3.0E GHz, linux 2.6.0 (g77 3.3.1)"
set compile = "g77 -malign-double -O3 -funroll-loops -fexpensive-optimizations"
# set compile = "g77 -O3"

set exe = ./a.out   # r.h.s should be replaced with "./a.exe" for cygwin
echo "Fortran Benchmark Tests"
echo "machine = $machine"
echo "compile with [ $compile ]"
echo "date = `date`"
@ n = 0
@ m = 0

foreach f ( intgl4.f intosc.f intpi3.f jacobi11.f jacobi1h.f leqs1k.f leqs4h.f mathfnc1.f mathfnc2.f matvec.f matvecz.f permute1.f permute2.f permute3.f runge.f)
  echo "------------------------------------------------------------------------------"
  @ n = $n + 1
  echo "($n) program = $f"
  if(-e $exe) \rm -f $exe
  $compile $f
  if($status == 0 && -f $exe) then
    time $exe
    if($status == 0) then
      @ m = $m + 1
    else
      echo "ERROR in Run"
    endif
  else
    echo "ERROR in Compile"
  endif
end
  echo "------------------------------------------------------------------------------"
echo "completed at `date`"
if ($m != $n) then
  echo "ERROR: only $m among $n programs have been run."
endif
