#!/bin/csh
# run two jobs simultaneously
# 2007/8/22
#

setenv LANG C

set machine = "nt1, Pentium4 3.0E GHz, linux 2.6.0 (g77 3.3.1), 2jobs"
set compile = "g77 -malign-double -O3 -funroll-loops -fexpensive-optimizations"
# set compile = "g77 -O3"

set exe = ./a.out   # r.h.s should be replaced with "./a.exe" for cygwin
set log1 = ./bench.p1.log
set log2 = ./bench.p2.log

echo "Fortran Benchmark Tests" |tee $log1|tee $log2
echo "machine = $machine" |tee -a $log1|tee -a $log2
echo "compile with [ $compile ]" |tee -a $log1|tee -a $log2
echo "date = `date`"  |tee -a $log1|tee -a $log2
@ n = 0
@ m = 0

foreach f ( intgl4.f intosc.f intpi3.f jacobi11.f jacobi1h.f leqs1k.f leqs4h.f mathfnc1.f mathfnc2.f matvec.f matvecz.f permute1.f permute2.f permute3.f runge.f)
  echo "------------------------------------------------------------------------------" |tee -a $log1|tee -a $log2
  @ n = $n + 1
  echo "($n) program = $f" |tee -a $log1|tee -a $log2
  if(-e $exe) \rm -f $exe
  $compile $f
  if($status == 0 && -f $exe) then
    (date; time $exe; date) >>& $log1 &
    set b1 = $!
    (date; time $exe; date) >>& $log2 &
    set b2 = $!
    sleep 15
    while(1)
      set n1 = `ps -p $b1 |wc -l`
      set n2 = `ps -p $b2 |wc -l`
      if($n1<2 && $n2<2) break
      sleep 15
    end
  else
    echo "ERROR in Compile" |tee -a $log1|tee -a $log2
  endif
end
  echo "------------------------------------------------------------------------------" |tee -a $log1|tee -a $log2
echo "completed at `date`" |tee -a $log1|tee -a $log2
echo "Outputs were written to $log1 and $log2."
